package com.mysoftkey.hibernate.helloworld;

import java.util.Iterator;
import java.util.List;

import org.hibernate.HibernateException;
import org.hibernate.Session;
import org.hibernate.Transaction;

public class CourseMain {

  public static void main(String[] args) {
    CourseMain obj = new CourseMain();

    Course course = new Course("Computer Science");
    Long cid = obj.saveCourse(course);
    System.out.println("id generated: " + cid);
    List<Course> list = obj.listCourse();
    for (Course courseObj : list) {
      System.out.println("course Id: " + courseObj.getId() + " , course name: " + courseObj.getName());
    }
    /* obj.updateCourse(cid, "Mathematics");
     obj.deleteCourse(cid);
     List<Course> list2 = obj.listCourse();*/
  }

  public Long saveCourse(Course course) {
    Session session = HibernateUtil.getSessionFactory().openSession();
    Transaction transaction = null;
    Long courseId = null;
    try {
      // begin transaction to start db activity
      transaction = session.beginTransaction();

      // Save course object to database
      courseId = (Long) session.save(course);

      // commit saved object
      transaction.commit();

    } catch (HibernateException e) {

      // roll back if exception occurred.
      transaction.rollback();
      e.printStackTrace();
    } finally {
      session.close();
    }
    return courseId;
  }

  /**
   * This method return all course from the db. assuming less no of record added
   * in database
   * 
   * @return
   */
  public List<Course> listCourse() {
    Session session = HibernateUtil.getSessionFactory().openSession();
    Transaction transaction = null;
    List<Course> courses = null;
    try {
      transaction = session.beginTransaction();
      courses = session.createQuery("from Course").list();
      for (Iterator iterator = courses.iterator(); iterator.hasNext();) {
        Course course = (Course) iterator.next();
        System.out.println(course.getName());
      }
      transaction.commit();
    } catch (HibernateException e) {
      transaction.rollback();
      e.printStackTrace();
    } finally {
      session.close();
    }
    return courses;
  }

  /**
   * This method return update course to database.
   * 
   * @param courseId
   * @param courseName
   */
  public void updateCourse(Long courseId, String courseName) {
    Session session = HibernateUtil.getSessionFactory().openSession();
    Transaction transaction = null;
    try {
      transaction = session.beginTransaction();
      Course course = (Course) session.get(Course.class, courseId);
      course.setName(courseName);
      transaction.commit();
    } catch (HibernateException e) {
      transaction.rollback();
      e.printStackTrace();
    } finally {
      session.close();
    }
  }

  /**
   * This method is used to delete course by id.
   * 
   * @param courseId
   */
  public void deleteCourse(Long courseId) {
    Session session = HibernateUtil.getSessionFactory().openSession();
    Transaction transaction = null;
    try {
      transaction = session.beginTransaction();
      Course course = (Course) session.get(Course.class, courseId);
      session.delete(course);
      transaction.commit();
    } catch (HibernateException e) {
      transaction.rollback();
      e.printStackTrace();
    } finally {
      session.close();
    }
  }

}
